// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/pln"
	model "LAPP_ACURA_MOM_BACKEND/models/pln"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ToyotaDeliveryOrderErrorLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ToyotaDeliveryOrderErrorLst的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2022-02-16 10:14:04
 *
 ******************************************************************************/
type ToyotaDeliveryOrderErrorLstDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewToyotaDeliveryOrderErrorLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ToyotaDeliveryOrderErrorLstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : ToyotaDeliveryOrderErrorLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2022-02-16 10:14:04
 *
 ******************************************************************************/
func NewToyotaDeliveryOrderErrorLstDAOImplement(session *xorm.Session, plantNr int, userid string) *ToyotaDeliveryOrderErrorLstDAOImplement {
	return &ToyotaDeliveryOrderErrorLstDAOImplement{session, &meta.ToyotaDeliveryOrderErrorLst, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) InsertOne(entity *model.ToyotaDeliveryOrderErrorLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) DeleteOne(demandId string, pos int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, demandId, pos}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) SelectOne(demandId string, pos int) (*model.ToyotaDeliveryOrderErrorLst, error) {
	var data model.ToyotaDeliveryOrderErrorLst
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, demandId, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) UpdateOne(entity *model.ToyotaDeliveryOrderErrorLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.Insert
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) Insert(entities *[]model.ToyotaDeliveryOrderErrorLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.Delete
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) Delete(entities *[]model.ToyotaDeliveryOrderErrorLst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ToyotaDeliveryOrderErrorLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.Select
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ToyotaDeliveryOrderErrorLst, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ToyotaDeliveryOrderErrorLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.ToyotaDeliveryOrderErrorLst_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ToyotaDeliveryOrderErrorLst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.SelectCols
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) SelectCols(predicates []grmi.Predicate, orderByFields []grmi.Field, cloumns []string) ([]map[string]interface{}, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ToyotaDeliveryOrderErrorLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.ToyotaDeliveryOrderErrorLst_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]map[string]interface{}, 0, 10)
	err := session.Cols(cloumns...).Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ToyotaDeliveryOrderErrorLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.ToyotaDeliveryOrderErrorLst_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			if orderBy == " order by " {
				orderBy += field.ColumnName
			} else {
				orderBy += ", " + field.ColumnName
			}
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ToyotaDeliveryOrderErrorLst, 0, 10)
	where = " where " + where
	err = impl.session.Table(impl.meta.TableName).SQL("select * from ["+impl.meta.TableName+"]"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.Update
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) Update(entities *[]model.ToyotaDeliveryOrderErrorLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/pln/ToyotaDeliveryOrderErrorLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *ToyotaDeliveryOrderErrorLstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.ToyotaDeliveryOrderErrorLst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ToyotaDeliveryOrderErrorLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.ToyotaDeliveryOrderErrorLst_LastUser.Name)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
